CVE Vulnerabilities

CVE-2022-22720

Inconsistent Interpretation of HTTP Requests ('HTTP Request/Response Smuggling')

Published: Mar 14, 2022 | Modified: May 17, 2022
CVSS 3.x
9.8
CRITICAL
Source:
NVD
CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H
CVSS 2.x
7.5 HIGH
AV:N/AC:L/Au:N/C:P/I:P/A:P
RedHat/V2
RedHat/V3
7.1 IMPORTANT
CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L
Ubuntu

Apache HTTP Server 2.4.52 and earlier fails to close inbound connection when errors are encountered discarding the request body, exposing the server to HTTP Request Smuggling

Weakness

The product acts as an intermediary HTTP agent (such as a proxy or firewall) in the data flow between two entities such as a client and server, but it does not interpret malformed HTTP requests or responses in ways that are consistent with how the messages will be processed by those entities that are at the ultimate destination.

Affected Software

Name Vendor Start Version End Version
Http_server Apache * 2.4.52
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-apr-util-0:1.6.1-91.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-curl-0:7.78.0-3.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-httpd-0:2.4.37-80.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-mod_cluster-native-0:1.3.16-10.Final_redhat_2.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-mod_http2-0:1.15.7-22.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-mod_jk-0:1.2.48-29.redhat_1.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-mod_md-1:2.0.8-41.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-mod_security-0:2.9.2-68.GA.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-nghttp2-0:1.39.2-41.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-openssl-1:1.1.1g-11.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-openssl-chil-0:1.0.0-11.el8jbcs *
JBoss Core Services for RHEL 8 RedHat jbcs-httpd24-openssl-pkcs11-0:0.4.10-26.el8jbcs *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-apr-util-0:1.6.1-91.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-curl-0:7.78.0-3.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-httpd-0:2.4.37-80.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-mod_cluster-native-0:1.3.16-10.Final_redhat_2.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-mod_http2-0:1.15.7-22.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-mod_jk-0:1.2.48-29.redhat_1.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-mod_md-1:2.0.8-41.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-mod_security-0:2.9.2-68.GA.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-nghttp2-0:1.39.2-41.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-openssl-1:1.1.1g-11.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-openssl-chil-0:1.0.0-11.jbcs.el7 *
JBoss Core Services on RHEL 7 RedHat jbcs-httpd24-openssl-pkcs11-0:0.4.10-26.jbcs.el7 *
Red Hat Enterprise Linux 6 Extended Lifecycle Support RedHat httpd-0:2.2.15-70.el6_10 *
Red Hat Enterprise Linux 7 RedHat httpd-0:2.4.6-97.el7_9.5 *
Red Hat Enterprise Linux 7.3 Advanced Update Support RedHat httpd-0:2.4.6-45.el7_3.8 *
Red Hat Enterprise Linux 7.4 Advanced Update Support RedHat httpd-0:2.4.6-67.el7_4.9 *
Red Hat Enterprise Linux 7.6 Advanced Update Support RedHat httpd-0:2.4.6-89.el7_6.4 *
Red Hat Enterprise Linux 7.6 Telco Extended Update Support RedHat httpd-0:2.4.6-89.el7_6.4 *
Red Hat Enterprise Linux 7.6 Update Services for SAP Solutions RedHat httpd-0:2.4.6-89.el7_6.4 *
Red Hat Enterprise Linux 7.7 Advanced Update Support RedHat httpd-0:2.4.6-90.el7_7.3 *
Red Hat Enterprise Linux 7.7 Telco Extended Update Support RedHat httpd-0:2.4.6-90.el7_7.3 *
Red Hat Enterprise Linux 7.7 Update Services for SAP Solutions RedHat httpd-0:2.4.6-90.el7_7.3 *
Red Hat Enterprise Linux 8 RedHat httpd:2.4-8050020220321170448.c5368500 *
Red Hat Enterprise Linux 8.1 Update Services for SAP Solutions RedHat httpd:2.4-8010020220321173048.c27ad7f8 *
Red Hat Enterprise Linux 8.2 Extended Update Support RedHat httpd:2.4-8020020220321171949.4cda2c84 *
Red Hat Enterprise Linux 8.4 Extended Update Support RedHat httpd:2.4-8040020220321171351.522a0ee4 *
Red Hat JBoss Core Services 1 RedHat jbcs-httpd24-httpd *
Red Hat Software Collections for Red Hat Enterprise Linux 7 RedHat httpd24-httpd-0:2.4.34-23.el7.2 *
Apache2 Ubuntu bionic *
Apache2 Ubuntu devel *
Apache2 Ubuntu esm-infra/xenial *
Apache2 Ubuntu focal *
Apache2 Ubuntu impish *
Apache2 Ubuntu jammy *
Apache2 Ubuntu trusty *
Apache2 Ubuntu trusty/esm *
Apache2 Ubuntu upstream *
Apache2 Ubuntu xenial *

Extended Description

HTTP requests or responses (“messages”) can be malformed or unexpected in ways that cause web servers or clients to interpret the messages in different ways than intermediary HTTP agents such as load balancers, reverse proxies, web caching proxies, application firewalls, etc. For example, an adversary may be able to add duplicate or different header fields that a client or server might interpret as one set of messages, whereas the intermediary might interpret the same sequence of bytes as a different set of messages. For example, discrepancies can arise in how to handle duplicate headers like two Transfer-encoding (TE) or two Content-length (CL), or the malicious HTTP message will have different headers for TE and CL. The inconsistent parsing and interpretation of messages can allow the adversary to “smuggle” a message to the client/server without the intermediary being aware of it. This weakness is usually the result of the usage of outdated or incompatible HTTP protocol versions in the HTTP agents.

Potential Mitigations

References